#include "stdio.h"
#include "stdlib.h"
#include "string.h"
#include "MQTTClient.h"
#include "road_NS_SN.h" // include the file.h of the generated automata code 


#define ADDRESS     "tcp://localhost:1883" //Address where to connect
#define CLIENTID    "CEP_ROAD_NS_SN"   // Client ID
#define TOPIC       "ROAD_NS_SN"		//Topic where the client will subscribe to receive information
#define TOPIC1      "Result" //Topic where the client will publish its messages
#define QOS         1 	     // Definition of the quality of service
#define TIMEOUT     10000L   // Timeout


int Nice_Sophia=0;
int Sophia_Nice=0;
int accident_r1=0;
int accident_r2=0;
int road_closed_r1=0;
int road_closed_r2=0;
int nbr_cars_r1_more_than_20=0;
int nbr_cars_r2_more_than_20=0;
int roadworks_r1=0;
int roadworks_r2=0;
int road_1_alarm=0;
int road_1_ok=0;
int road_2_alarm=0;
int road_2_ok=0;


MQTTClient client; //A handle representing an MQTT client
MQTTClient_deliveryToken deliveredtoken; //A value representing an MQTT message. A delivery token is returned to the client application when a message is published. The token can then be used to check that the message was successfully delivered to its destination
MQTTClient_message pubmsg = MQTTClient_message_initializer;//A structure representing the payload and attributes of an MQTT message 

  
 
	void connlost(void *context, char *cause)  // This is a callback function.callback function. You can set this to NULL if your application doesn't handle disconnections. 
	{
    printf("\nConnection lost\n");
    printf("     cause: %s\n", cause);
	}

   
	void delivered(void *context, MQTTClient_deliveryToken dt) //This is a callback function. The client application must provide an implementation of this function to enable notification of delivery of messages.
	{
    printf("Message with token value %d delivery confirmed\n", dt);
    deliveredtoken = dt;
	}



	/*************************************************TO DO : Finish the implementation of messageTest, msgArrived and main functions **********/
	   
	void messageTest(MQTTClient_message *message) // Treatement of the received message
	{
                  
						/*********** To implement*************/

				/*This function should receive the message, breaks it into a series of tokens using a delimiter (you can use strtok function) (you can choose a delimiter: ";" but don't forget to use it during the test and put it at the end of the messageTest that you will send(publish) during the test (see tutorial test part)).
After that you should use these tokens to make the test and see if they are equal to the inputs (you can use the function strncmp) , if yes the considered input will have the value 1 
ex : 
if (!strncmp(token,"Nice_Sophia",strlen(token)))
		Nice_Sophia=1;
*/
 
 	MQTTClient_freeMessage(&message); //This function frees memory allocated to an MQTT message

 	}




	int msgArrived(void *context, char *topicName, int topicLen, MQTTClient_message *message) /*This is a callback function. The client application must provide an implementation of this function to enable receipt of messages. The function is registered with the client library by passing it as an argument to MQTTClient_setCallbacks(). It is called by the client library when a new message that matches a client subscription has been received from the server.*/

	{  char* PAYLOAD=""; // message to publish
 												 /*********** To implement*************/
  /*

     1/ call messageTest() function;
     2/ call the automaton method of the CEP Model
     3/ Make the test about the outputs and define the message to publish by the CEP
    ex: 
	if ((road_1_alarm == 1) && (road_2_alarm == 1))
	PAYLOAD = "road_1_alarm ; road_2_alarm ";
	
      4/ Create the MQTTpublishMessage
	
      5/ Publish the message by the MQTT Client
    */

  
    //Display of the published message + topic + client ID + Timeout
 	printf("Waiting for up to %d seconds for publication of %s\n on topic %s for client with ClientID: %s\n", (int)(TIMEOUT/1000), PAYLOAD, TOPIC1, CLIENTID);
  
     putchar('\n');
 
    MQTTClient_freeMessage(&message); // Free the message
    MQTTClient_free(topicName); // Free the topicName
    return 1;
	}



    //Main Method
	int main(int argc, char* argv[])
	{	
                       
                       
 												 /*********** To implement*************/
             
      //1- TO DO:  call of the reset_automaton method
    
	 // 2- TO DO: call of the automaton method: we should call it here also to execute it in the first logical instant 
   
    MQTTClient_connectOptions conn_opts = MQTTClient_connectOptions_initializer; // Definition of the connection option of the MQTT_Client
    
    int rc; 
    int ch;


    // Creation of the client and definition of its connection options 
    MQTTClient_create(&client, ADDRESS, CLIENTID, MQTTCLIENT_PERSISTENCE_NONE, NULL);
    conn_opts.keepAliveInterval = 20;
    conn_opts.cleansession = 1;

    
    MQTTClient_setCallbacks(client, NULL, connlost, msgArrived, delivered); //This function sets the callback functions for a specific client. 
  

    if ((rc = MQTTClient_connect(client, &conn_opts)) != MQTTCLIENT_SUCCESS) // MQTTClient_connect: This function attempts to connect a previously-created client
    {   printf("Failed to connect, return code %d\n", rc);
        exit(EXIT_FAILURE);
    }
   
      printf("Subscribing to topic %s\nfor client %s using QoS%d\n\n Press Q<Enter> to quit\n\n", TOPIC, CLIENTID, QOS);
       //Subscription of the client to the topic
      MQTTClient_subscribe(client, TOPIC, QOS);

	    do 
   		 {
       		 ch = getchar();
   		 } while(ch!='Q' && ch != 'q');
 
		rc = MQTTClient_waitForCompletion(client, deliveredtoken, TIMEOUT); // MQTTClient_waitForCompletion: This function is called by the client application to synchronize execution of the main thread with completed publication of a message
    	return rc;
}
